package de.mlessmann.certassist;

import de.mlessmann.certassist.openssl.CertificateRequest;
import de.mlessmann.certassist.openssl.CertificateRequest.RequestType;
import de.mlessmann.certassist.openssl.CertificateRequestExtension;
import de.mlessmann.certassist.openssl.CertificateSubject;
import de.mlessmann.certassist.openssl.OpenSSLCertificateCreator;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;

class TestOpenSSLCertificateCreator {

    private OpenSSLCertificateCreator openSSLCertificateCreator;

    @BeforeEach
    void setUp() {
        ExecutableResolver executableResolver = new ExecutableResolver();
        openSSLCertificateCreator = new OpenSSLCertificateCreator(executableResolver);
    }

    @Test
    void testCertificateCreation() throws Exception {
        CertificateRequest certRequest = CertificateRequest
            .builder()
            .commonName("test.home")
            .type(RequestType.STANDALONE_CERTIFICATE)
            .subject(CertificateSubject.builder().country("DE").state("SH").locality("HH").organization("Crazy-Cats"))
            .extension(CertificateRequestExtension.builder().alternativeNames("test2.home", "test3.home"))
            .build();

        try (var cert = openSSLCertificateCreator.createCertificate(certRequest)) {
            System.out.println("Certificate created: " + cert);
        }
    }
}
